#pragma once

#include "transform.hpp"
#include "types.hpp"


static inline auto togray_f   = [](rgb16 x) -> uint16_t { return static_cast<uint16_t>((x.r + x.g + x.b) / 3); };
static inline auto subquant_f = [](uint16_t x) -> uint8_t { return static_cast<uint8_t>(x / 256); };


void togray(image2d<rgb16> input, image2d<uint16_t> output, rect roi);
void subquantize8(image2d<uint16_t> input, image2d<uint8_t> output, rect roi);


template <Image2D I>
auto togray_view(I input)
{
  return transform(input, togray_f);
}

template <Image2D I>
auto subquantize8_view(I input)
{
  return transform(input, subquant_f);
}
