#pragma once

#include "types.hpp"

template <class U, class V, class F>
void apply(U in, V out, rect roi, F f)
{
  int y1 = roi.y + roi.height;
  int x1 = roi.x + roi.width;
  for (int y = roi.y; y < y1; ++y)
    for (int x = roi.x; x < x1; ++x)
      out({x, y}) = f(in({x, y}));
}

template <Image2D U, class T>
void copy_to(U in, image2d<T> out, rect roi)
{
  for (int y = 0; y < roi.height; ++y)
    for (int x = 0; x < roi.width; ++x)
      out({x, y}) = in({roi.x + x, roi.y + y});
}
