#pragma once

#include "types.hpp"


template <class T>
image2d<T> create_image(int width, int height);

void destroy_image(image2d<void> f);


template <class T>
void fill_with_random_values(image2d<T> out, rect roi);

/******************************************/
/****          Implementation          ****/
/******************************************/

namespace details
{
  void create_image(int width, int height, std::size_t size, image2d<void>& out);
  void fill_with_random_values(image2d<void> out, std::size_t bsize, rect roi);
} // namespace details


template <class T>
image2d<T> create_image(int width, int height)
{
  image2d<T> out;
  details::create_image(width, height, sizeof(T), out);
  return out;
}

template <class T>
void fill_with_random_values(image2d<T> out, rect roi)
{
  details::fill_with_random_values(out, sizeof(T), roi);
}
