#pragma once

#include "types.hpp"

#include <utility>


template <class I, class F>
struct transformed_image_t
{
  auto operator()(point p) { return m_fun(m_input(p)); }
  auto operator()(point p) const { return m_fun(m_input(p)); }

  I m_input;
  F m_fun;
};

template <Image2D I, class F>
auto transform(I input, F fun) -> transformed_image_t<I, F>
{
  return {std::move(input), std::move(fun)};
}
