#include "image.hpp"
#include <cstdlib>

namespace details
{

  void create_image(int width, int height, std::size_t size, image2d<void>& out)
  {
    out.m_buffer      = (std::byte*)std::malloc(width * height * size);
    out.m_byte_stride = width * size;
  }


  void fill_with_random_values(image2d<void> out, std::size_t bsize, rect roi)
  {
    int y1 = roi.y + roi.height;
    int x0 = roi.x * bsize;
    int x1 = (roi.x + roi.width) * bsize;

    for (int y = roi.y; y < y1; ++y)
    {
      uint8_t* lineptr = (uint8_t*)out.m_buffer + out.m_byte_stride * y;
      for (int x = x0; x < x1; ++x)
        lineptr[x] = uint8_t(std::rand());
    }
  }
} // namespace details

void destroy_image(image2d<void> f)
{
  std::free(f.m_buffer);
}
